#include "/lib/all_the_uniforms.glsl"


#include "/lib/settings.glsl"
#include "/lib/tonemap.glsl"

#include "/lib/util.glsl"
#include "/global/sky.glsl"
#include "/global/fog.glsl"

// Fog

varying vec2 texcoord;

/* DRAWBUFFERS:0 */

void main() {
	gl_FragData[0] = texture2D(colortex0, texcoord);

	float Depth = texture2D(depthtex0, texcoord).x;
	vec3 ViewPos = to_view_pos(vec3(texcoord, Depth));
	vec3 PlayerPos = mat3(gbufferModelViewInverse) * ViewPos;

	float Dist = length(PlayerPos);
	float HorizontalDist = length(PlayerPos.xz);
	#ifdef BORDER_FOG
	if(Depth < 1) {
		vec3 SkyColor = texture2D(colortex1, texcoord).rgb;
		#ifdef DIMENSION_OVERWORLD
		gl_FragData[0].xyz = get_atm_fog(Dist, gl_FragData[0].xyz, PlayerPos + cameraPosition);
		#endif
		gl_FragData[0].xyz = get_border_fog(HorizontalDist/far, gl_FragData[0].xyz, SkyColor);	
	}
	#endif
	
	gl_FragData[0].xyz = get_blindness_fog(Dist, gl_FragData[0].xyz);
	gl_FragData[0].xyz = get_lava_fog(Dist, gl_FragData[0].xyz, fogColor);
}

