#include "/lib/all_the_uniforms.glsl"
#include "/lib/util.glsl"
#include "/lib/tonemap.glsl"
#include "/lib/blur.glsl"
#include "/lib/settings.glsl"

// Write to bloom buffer, TAA Begin
#ifdef BLOOM
const bool colortex0MipmapEnabled = true;
#endif

varying vec2 texcoord;

/* DRAWBUFFERS:13 */

void main() {
	#ifdef BLOOM
	gl_FragData[0] = vec4(0, 0, 0, 1);
	int BloomTile = is_in_range(texcoord);
	if(BloomTile != 0) {
		float Offset = 0;
		for(int i = 3; i <= BloomTile; i++)
			Offset += 1/pow(2, i-1);
		gl_FragData[0] = write_bloom_buffer(texture2D(colortex0, (texcoord-Offset)*pow(2, BloomTile)));
	}

	#endif
	#if TAA_MODE != 0
	gl_FragData[1] = vec4(texture2D(colortex3, texcoord).rgb, 0);
	#endif
}
